/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.Date;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.CorridaCtrlDAO;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.CorridaCtrl;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.service.CorridaCtrlService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

/**
 * 
 * @author Administrador
 */
@Service("corridaCtrlService")
public class CorridaCtrlServiceImpl implements CorridaCtrlService {

	@Autowired
	private CorridaCtrlDAO corridaCtrlDAO;

	public CorridaCtrl obtenerID(Integer id) {
		return corridaCtrlDAO.obtenerID(id);
	}

	@Transactional
	public CorridaCtrl suscribir(CorridaCtrl entidad) {
		Integer usuarioId = null;
		if (UsuarioLogado.getUsuarioLogado() != null) {
			entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		}
		entidad.setUsuarioId(usuarioId);
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return corridaCtrlDAO.suscribir(entidad);
	}

	@Transactional
	public CorridaCtrl actualizacion(CorridaCtrl entidad) {
		Integer usuarioId = 1;
		if (UsuarioLogado.getUsuarioLogado() != null) {
			usuarioId = UsuarioLogado.getUsuarioLogado().getUsuarioId();
		}
		entidad.setUsuarioId(usuarioId);
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return corridaCtrlDAO.actualizacion(entidad);
	}

	public CorridaCtrl buscar(Ruta ruta, ClaseServicio claseServicio, Marca marca, Date horario, boolean pisoExtra) {
		return corridaCtrlDAO.buscar(ruta, claseServicio, marca, horario, pisoExtra);
	}

	@Override
	public CorridaCtrl buscar(Integer corridaId, Parada origem, Parada destino, ClaseServicio claseServicio, Marca marca) {
		return corridaCtrlDAO.buscar(corridaId, origem, destino, claseServicio, marca);
	}
}
